// AddDialplanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "VaxTeleConfigDlg.h"
#include "AddDialplanDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddDialplanDlg dialog


CAddDialplanDlg::CAddDialplanDlg() : CPropertyPage(CAddDialplanDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddDialplanDlg)
	m_sUserPrefix = _T("");
	m_sCallPrefix = _T("");
	//}}AFX_DATA_INIT

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}


void CAddDialplanDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDialplanDlg)
	DDX_Control(pDX, IDC_COMBO_DIAL_PLAN_LINES, m_ctrlComboLine);
	DDX_Control(pDX, IDC_LIST_DIAL_PLAN, m_ctrlDialPlanList);
	DDX_Text(pDX, IDC_EDIT_DIAL_PLAN_USER_PREFIX, m_sUserPrefix);
	DDX_Text(pDX, IDC_EDIT_DIAL_PLAN_DIAL_PREFIX, m_sCallPrefix);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddDialplanDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddDialplanDlg)
	ON_BN_CLICKED(IDC_BUTTON_DIAL_PLAN_ADD, OnButtonDialPlanAdd)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_DIAL_PLAN_REMOVE, OnButtonSaveDialPlanRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddDialplanDlg message handlers

BOOL CAddDialplanDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("ShowDialPlans", NULL);

	m_ctrlDialPlanList.InsertColumn(0, "User Prefix", LVCFMT_LEFT, 120);
	m_ctrlDialPlanList.InsertColumn(1, "Line Name", LVCFMT_LEFT, 180);
	m_ctrlDialPlanList.InsertColumn(2, "Call Prefix", LVCFMT_LEFT, 120);

	m_ctrlComboLine.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddDialplanDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "AddLine") == 0 && pParamList->GetCount() == 1)
	{
		CString objLine= pParamList->GetHead();
		m_ctrlComboLine.AddString(objLine);
				
		return;
	}
	
	if(::lstrcmpi(sCommand, "RemoveLine") == 0 && pParamList->GetCount() == 1)
	{
		int nIndex = m_ctrlComboLine.FindStringExact(0, pParamList->GetHead());
		if(nIndex != -1) m_ctrlComboLine.DeleteString(nIndex);
						
		return;
	}
	
	if(::lstrcmpi(sCommand, "ShowLines") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objLine = pParamList->GetAt(pParamList->FindIndex(nCount));
			m_ctrlComboLine.AddString(objLine);
		}

		m_ctrlComboLine.SetCurSel(0);

		return;
	}
	
	if(::lstrcmpi(sCommand, "ShowDialPlans") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objDialPlan = pParamList->GetAt(pParamList->FindIndex(nCount));
			
			CStringList objParamList;
			CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->ParseToStringList(objDialPlan, &objParamList);
			
			m_ctrlDialPlanList.InsertItem(nCount, objParamList.RemoveHead());
			m_ctrlDialPlanList.SetItemText(nCount, 1, objParamList.RemoveHead());
			m_ctrlDialPlanList.SetItemText(nCount, 2, objParamList.RemoveHead());
		}
				
		return;
	}

	if(::lstrcmpi(sCommand, "AddDialPlan") == 0 && pParamList->GetCount() == 3)
	{
		CString sUserPrefix = pParamList->GetAt(pParamList->FindIndex(0));
		CString sLineName   = pParamList->GetAt(pParamList->FindIndex(1));
		CString sCallPrefix = pParamList->GetAt(pParamList->FindIndex(2));
		
		int nCount = m_ctrlDialPlanList.GetItemCount();

		m_ctrlDialPlanList.InsertItem(nCount, sUserPrefix);
		m_ctrlDialPlanList.SetItemText(nCount, 1, sLineName);
		m_ctrlDialPlanList.SetItemText(nCount, 2, sCallPrefix);

		return;
	}

	if(::lstrcmpi(sCommand, "RemoveDialPlan") == 0 && pParamList->GetCount() == 1)
	{
		LVFINDINFO ListFindInfo;

		ListFindInfo.flags = LVFI_STRING;
		ListFindInfo.psz   = pParamList->GetHead();

		int nItemIndex = m_ctrlDialPlanList.FindItem(&ListFindInfo);
		if(nItemIndex == -1) return;
		
		m_ctrlDialPlanList.DeleteItem(nItemIndex);

		return;
	}

}


void CAddDialplanDlg::OnButtonDialPlanAdd() 
{
	UpdateData();

	if(m_sUserPrefix.IsEmpty())
	{
		MessageBox("Please enter user prefix.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	LVFINDINFO ListFindInfo;
	
	ListFindInfo.flags = LVFI_STRING;
	ListFindInfo.psz = m_sUserPrefix;

	if(m_ctrlDialPlanList.FindItem(&ListFindInfo) != -1)
	{
		MessageBox("Dialplan that user dials phone no with prefix " + m_sUserPrefix + " is already exist.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	int nCount = m_ctrlComboLine.GetCurSel();
	if(nCount == -1) 
	{	
		MessageBox("Please select the line.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	CString objLineName; 
	m_ctrlComboLine.GetLBText(nCount, objLineName);

	CStringList objParamList;
	
	objParamList.AddTail(m_sUserPrefix);
	objParamList.AddTail(objLineName);
	objParamList.AddTail(m_sCallPrefix);
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("AddDialPlan", &objParamList);
}

void CAddDialplanDlg::OnButtonSaveDialPlanRemove() 
{
	int nItemIndex = m_ctrlDialPlanList.GetNextItem(-1, LVNI_SELECTED);
	if(nItemIndex == -1)
	{	
		MessageBox("Please select a dial plan.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	CString objUserPrefix = m_ctrlDialPlanList.GetItemText(nItemIndex, 0);

	CStringList objParamList;
	objParamList.AddTail(objUserPrefix);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("RemoveDialPlan", &objParamList);
}

