// ClientRegisterEvent.cpp: implementation of the CClientRegisterEvent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSIP.h"
#include "Registry.h"
#include "ClientRegisterEvent.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClientRegisterEvent::CClientRegisterEvent()
{

}

CClientRegisterEvent::~CClientRegisterEvent()
{

}

void CClientRegisterEvent::SetDomainRealm(LPCTSTR sDomainRealm)
{
	//m_sDomainRealm = sDomainRealm   //Restrict client to add correct domain in the ToURI.
}

void CClientRegisterEvent::OnClientRegister(LPCTSTR sUserLogin, LPCTSTR sDomain, long lRegId) 
{
	//if(m_sDomainRealm != sDomain)  // Restrict client to add correct domain in the ToURI.
	//{
	//	RejectClientRegister(lRegId);
	//	return;
	//}
		
	CRegistry objReg;
	CLoginReg objLoginReg;
	
	if(!objReg.GetLogin(sUserLogin, &objLoginReg))
	{
		if(!CServerSIP::m_pServerSIP->RejectClientRegister(lRegId))
			CServerSIP::m_pServerSIP->LogError("");

		return;
	}

	if(objLoginReg.m_bBlock)
	{
		if(!CServerSIP::m_pServerSIP->RejectClientRegister(lRegId))
			CServerSIP::m_pServerSIP->LogError("");

		return;
	}

	CServerSIP::m_pServerSIP->m_objUserList.AddUser(sUserLogin, objLoginReg.m_sPassword, objLoginReg.m_bStealth, objLoginReg.m_sCodec, objLoginReg.m_bBlock);
			
	if(!CServerSIP::m_pServerSIP->AuthClientRegister(lRegId))
		CServerSIP::m_pServerSIP->LogError("");
}

void CClientRegisterEvent::OnClientRegisterSuccess(LPCTSTR sUserLogin) 
{
}

void CClientRegisterEvent::OnClientUnRegister(LPCTSTR sUserLogin) 
{
	CServerSIP::m_pServerSIP->m_objUserList.RemoveUser(sUserLogin);
}

void CClientRegisterEvent::OnClientRegisterFail(LPCTSTR sUserLogin) 
{
	CServerSIP::m_pServerSIP->m_objUserList.RemoveUser(sUserLogin);
}
