// LineRegisterEvent.cpp: implementation of the CLineRegisterEvent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSIP.h"
#include "LineRegisterEvent.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLineRegisterEvent::CLineRegisterEvent()
{

}

CLineRegisterEvent::~CLineRegisterEvent()
{

}

void CLineRegisterEvent::OnLineRegisterTrying(long lLineId) 
{
	CLineData* pLineName = CServerSIP::m_pServerSIP->m_objLineList.FindLine(lLineId);

	if(pLineName != NULL)
		CServerSIP::m_pServerSIP->LogStatus("Trying to register Line Name = " + pLineName->m_sLineName);
}

void CLineRegisterEvent::OnLineRegisterFail(long lLineId, long lStatusCode, LPCTSTR sReasonPhrase) 
{
	CLineData* pLineName = CServerSIP::m_pServerSIP->m_objLineList.FindLine(lLineId);
	
	if(pLineName != NULL)
		CServerSIP::m_pServerSIP->LogStatus("Fail to register Line Name = " + pLineName->m_sLineName);
}

void CLineRegisterEvent::OnLineRegisterSuccess(long lLineId) 
{
	CLineData* pLineName = CServerSIP::m_pServerSIP->m_objLineList.FindLine(lLineId);
	
	if(pLineName != NULL)
		CServerSIP::m_pServerSIP->LogStatus("Success to register Line Name = " + pLineName->m_sLineName);
}


void CLineRegisterEvent::OnLineUnRegisterTrying(long lLineId) 
{
	CLineData* pLineName = CServerSIP::m_pServerSIP->m_objLineList.FindLine(lLineId);

	if(pLineName != NULL)
		CServerSIP::m_pServerSIP->LogStatus("Trying to un-register Line Name = " + pLineName->m_sLineName);
}

void CLineRegisterEvent::OnLineUnRegisterFail(long lLineId, long lStatusCode, LPCTSTR sReasonPhrase) 
{
	CLineData* pLineName = CServerSIP::m_pServerSIP->m_objLineList.FindLine(lLineId);
	
	if(pLineName != NULL)
		CServerSIP::m_pServerSIP->LogStatus("Fail to un-register Line Name = " + pLineName->m_sLineName);
}

void CLineRegisterEvent::OnLineUnRegisterSuccess(long lLineId) 
{
	CLineData* pLineName = CServerSIP::m_pServerSIP->m_objLineList.FindLine(lLineId);
	
	if(pLineName != NULL)
		CServerSIP::m_pServerSIP->LogStatus("Success to un-register Line Name = " + pLineName->m_sLineName);
}
